<?xml version="1.0" encoding="utf-8"?>
<application>
    <name>Tasks</name>
    <version>7.2</version>
    <order>30</order>
    <depends>
        <application>Admin</application>
    </depends>
    <tables>
        <table>
            <name>tasks</name>
            <version>7</version>
            <declaration>
                <field>
                    <name>id</name>
                    <type>text</type>
                    <length>40</length>
                    <notnull>true</notnull>
                </field>
                <field>
                    <name>container_id</name>
                    <type>integer</type>
                </field>
                <field>
                    <name>created_by</name>
                    <type>text</type>
                    <length>40</length>
                </field>
                <field>
                    <name>creation_time</name>
                    <type>datetime</type>
                </field>
                <field>
                    <name>last_modified_by</name>
                    <type>text</type>
                    <length>40</length>
                </field>
                <field>
                    <name>last_modified_time</name>
                    <type>datetime</type>
                </field>
                <field>
                    <name>is_deleted</name>
                    <type>boolean</type>
                    <default>false</default>
                </field>
                <field>
                    <name>deleted_by</name>
                    <type>text</type>
                    <length>40</length>
                </field>
                <field>
                    <name>deleted_time</name>
                    <type>datetime</type>
                </field>
                <field>
                    <name>seq</name>
                    <type>integer</type>
                    <notnull>true</notnull>
                    <default>0</default>
                </field>
                <field>
                    <name>percent</name>
                    <type>integer</type>
                    <length>4</length>
                </field>
                <field>
                    <name>completed</name>
                    <type>datetime</type>
                </field>
                <field>
                    <name>due</name>
                    <type>datetime</type>
                </field>
                <field>
                     <name>start_time</name>
                     <type>datetime</type>
                </field>
                <field>
                    <name>class</name>
                    <type>text</type>
                    <length>40</length>
                    <default>PUBLIC</default>
                    <notnull>true</notnull>
                </field>
                <field>
                    <name>description</name>
                    <type>clob</type>
                </field>
                <field>
                    <name>geo</name>
                    <type>float</type>
                </field>
                <field>
                    <name>location</name>
                    <type>text</type>
                    <length>255</length>
                    <notnull>false</notnull>
                </field>
                    <field>
                    <name>organizer</name>
                    <type>text</type>
                    <length>40</length>
                </field>
                <field>
                    <name>originator_tz</name>
                    <type>text</type>
                    <length>255</length>
                </field>
                <field>
                    <name>priority</name>
                    <type>text</type>
                    <length>40</length>
                    <default>NORMAL</default>
                    <notnull>true</notnull>
                </field>
                <field>
                    <name>status</name>
                    <type>text</type>
                    <length>40</length>
                    <default>NEEDS-ACTION</default>
                    <notnull>true</notnull>
                </field>
                <field>
                    <name>summary</name>
                    <type>text</type>
                    <length>255</length>
                    <notnull>false</notnull>
                </field>
                <field>
                    <name>url</name>
                    <type>text</type>
                    <length>255</length>
                    <notnull>false</notnull>
                </field>
                <index>
                    <name>id</name>
                    <primary>true</primary>
                    <field>
                        <name>id</name>
                    </field>
                </index>
                <index>
                    <name>container_id</name>
                    <field>
                        <name>container_id</name>
                    </field>
                </index>
                <index>
                    <name>organizer</name>
                    <field>
                        <name>organizer</name>
                    </field>
                </index>
                <index>
                    <name>class</name>
                    <field>
                        <name>class</name>
                    </field>
                </index>
                <shard>
                    <backend>database</backend>
                    <keytable>tasks</keytable>
                    <filter>
                        <field>container_id</field>
                        <operator>in</operator>
                        <value>?</value>
                    </filter>
                </shard>
            </declaration>
        </table>

        <table>
            <name>tasks_contact</name>
            <version>1</version>
            <declaration>
                <field>
                    <name>task_id</name>
                    <type>text</type>
                    <length>40</length>
                    <notnull>true</notnull>
                </field>
                <field>
                    <name>contact_id</name>
                    <type>integer</type>
                    <notnull>true</notnull>
                </field>
                <index>
                    <name>task_id-contact_id</name>
                    <primary>true</primary>
                    <field>
                        <name>task_id</name>
                    </field>
                    <field>
                        <name>contact_id</name>
                    </field>
                </index>
               <index>
                    <name>task_contact::task_id--tasks::id</name>
                    <foreign>true</foreign>
                    <field>
                        <name>task_id</name>
                    </field>
                    <reference>
                        <table>tasks</table>
                        <field>id</field>
                        <ondelete>CASCADE</ondelete>
                        <!-- add onupdate? -->
                    </reference>
                </index>
                <shard>
                    <backend>database</backend>
                    <keytable>tasks</keytable>
                    <relation>
                        <field>task_id</field>
                        <reference>
                            <table>tasks</table>
                            <field>id</field>
                        </reference>
                    </relation>
                </shard>
            </declaration>
        </table>

    </tables>
</application>
